#!/usr/bin/env php
<?php

use Everyman\Neo4j\Client,
	Everyman\Neo4j\Index\NodeIndex,
	Everyman\Neo4j\Relationship,
	Everyman\Neo4j\Node;

die("Please, edit the code and point the path below to neo4jphp/examples/ directory.\n Then, remove this die(); \n\n");
require 'YOUR_PATH_GOES_HERE'.'/neo4jphp-master/examples/example_bootstrap.php';

$fp = fopen('def.csv', 'r');
$def = array();
while($line = fgetcsv($fp)) {
    $def[] = $line;
}
fclose($fp);

$fp = fopen('usage.csv', 'r');
$usage = array();
while($line = fgetcsv($fp)) {
    $usage[] = $line;
}
fclose($fp);

$fp = fopen('static.csv', 'r');
$static = array();
while($line = fgetcsv($fp)) {
    $static[] = $line;
}
fclose($fp);

$client = new Client();

$neo4j = array();
foreach($def as $id => $object) {
    $neo4j[$object[0]] = $client->makeNode()->setProperty('name', $object[0])->save();

    if (!empty($object[1])) {
        if (!isset($neo4j[$object[1]])) {
            $neo4j[$object[1]] = $client->makeNode()->setProperty('name', $object[1])->save();
        }
        $neo4j[$object[0]] ->relateTo($neo4j[$object[1]], 'EXTENDS')->save();
    }

    if (!empty($object[2])) {
        if (!isset($neo4j[$object[2]])) {
            $neo4j[$object[2]] = $client->makeNode()->setProperty('name', $object[2])->save();
        }
        $neo4j[$object[0]] ->relateTo($neo4j[$object[2]], 'IMPLEMENTS')->save();
    }
}

foreach($usage as $u) {
    list($caller, $called) = $u;
    if (!isset($neo4j[$caller])) {
        $neo4j[$caller] = $client->makeNode()->setProperty('name', $caller)->save();
    }
    if (!isset($neo4j[$called])) {
        $neo4j[$called] = $client->makeNode()->setProperty('name', $called)->save();
    }
    $neo4j[$caller]->relateTo($neo4j[$called], 'CALLS')->save();
}


foreach($static as $s) {
    list($caller, $called) = $s;
    if (!isset($neo4j[$caller])) {
        $neo4j[$caller] = $client->makeNode()->setProperty('name', $caller)->save();
    }
    if (!isset($neo4j[$called])) {
        $neo4j[$called] = $client->makeNode()->setProperty('name', $called)->save();
    }
    $neo4j[$caller]->relateTo($neo4j[$called], 'CALLS STATICALLY')->save();
}


?>